open Queues

(*************** mylist tests ***************)
let l = Node(1, Node(2, Node(3, Node(4, Empty))))

let rec mylist_to_string f lst = "" (* TODO: Write to string function *)

(* Result: '1 2 3 4 ' *)
let _ = print_string "*****Testing mylist*****\n"
let _ = print_string "Expected result: 1 2 3 4\n"
let _ = print_string ((mylist_to_string string_of_int l) ^ "\n")

(* Result: '4 3 2 1 ' *)
let _ = print_string "*****Testing mylist_rev*****\n"
let _ = print_string "Expected result: 4 3 2 1\n"
let _ = print_string ((mylist_to_string string_of_int (mylist_rev l)) ^ "\n")


(* Result: 'odd even odd even' *)
let mapped_l = mylist_map (fun n -> if n mod 2 = 0 then "even" else "odd") l
let _ = print_string "*****Testing mylist_map*****\n"
let _ = print_string "Expected result: odd even odd even\n"
let _ = print_string ((mylist_to_string (fun a -> a) mapped_l) ^ "\n")


(*************** queue1 tests ***************)
let rec queue1_to_string f (front, back) =  "" 
    (* TODO: Write to string function *)

let _ = print_string "*****Testing queue1*****\n"

(***** Testing enq1 and deq1 *****)
let q = empty_queue1
let q = enq1 q 1 
(* Result: '1' *)
let _ = print_string "Expected result: 1\n"
let _ = print_string ((queue1_to_string string_of_int q) ^ "\n")

let q = enq1 q 2
(* Result: '1 2' *)
let _ = print_string "Expected result: 1 2\n"
let _ = print_string ((queue1_to_string string_of_int q) ^ "\n")

let q = enq1 q 3
(* Result: '1 2 3' *)
let _ = print_string "Expected result: 1 2 3\n"
let _ = print_string ((queue1_to_string string_of_int q) ^ "\n")

let (_, q) = deq1 q 
(* Result: '2 3' *)
let _ = print_string "Expected result: 2 3\n"
let _ = print_string ((queue1_to_string string_of_int q) ^ "\n")

let q = enq1 q 4
(* Result: '2 3 4' *)
let _ = print_string "Expected result: 2 3 4\n"
let _ = print_string ((queue1_to_string string_of_int q) ^ "\n")

let (_, q) = deq1 q 
(* Result: '3 4' *)
let _ = print_string "Expected result: 3 4\n"
let _ = print_string ((queue1_to_string string_of_int q) ^ "\n")

let (_, q) = deq1 q 
(* Result: '4' *)
let _ = print_string "Expected result: 4\n"
let _ = print_string ((queue1_to_string string_of_int q) ^ "\n")

let (_, q) = deq1 q 
(* Result: '' *)
let _ = print_string "Expected result: ''\n"
let _ = print_string ((queue1_to_string string_of_int q) ^ "\n")

(***** Testing map1 *****)
let q = (enq1 (enq1 (enq1 (enq1 empty_queue1 1) 2) 3) 4)

let q = map1 (fun n -> if n mod 2 = 0 then "even" else "odd") q
(* Result: 'odd even odd even' *)
let _ = print_string "Expected result: odd even odd even\n"
let _ = print_string ((queue1_to_string (fun a -> a) q) ^ "\n")

(*************** queue2 tests ***************)

let rec list_to_string f lst = "" (* TODO: Write to_string function *)

let rec queue2_to_string f (front, back) = 
            (list_to_string f front) ^ (list_to_string f (List.rev back))

let _ = print_string "*****Testing queue2*****\n"

(***** Testing enq2 and deq2 *****)
let q = empty_queue2
let q = enq2 q 1 
(* Result: '1' *)
let _ = print_string "Expected result: 1\n"
let _ = print_string ((queue2_to_string string_of_int q) ^ "\n")

let q = enq2 q 2
(* Result: '1 2' *)
let _ = print_string "Expected result: 1 2\n"
let _ = print_string ((queue2_to_string string_of_int q) ^ "\n")

let q = enq2 q 3
(* Result: '1 2 3' *)
let _ = print_string "Expected result: 1 2 3\n"
let _ = print_string ((queue2_to_string string_of_int q) ^ "\n")

let (_, q) = deq2 q 
(* Result: '2 3' *)
let _ = print_string "Expected result: 2 3\n"
let _ = print_string ((queue2_to_string string_of_int q) ^ "\n")

let q = enq2 q 4
(* Result: '2 3 4' *)
let _ = print_string "Expected result: 2 3 4\n"
let _ = print_string ((queue2_to_string string_of_int q) ^ "\n")

let (_, q) = deq2 q 
(* Result: '3 4' *)
let _ = print_string "Expected result: 3 4\n"
let _ = print_string ((queue2_to_string string_of_int q) ^ "\n")

let (_, q) = deq2 q 
(* Result: '4' *)
let _ = print_string "Expected result: 4\n"
let _ = print_string ((queue2_to_string string_of_int q) ^ "\n")

let (_, q) = deq2 q 
(* Result: '' *)
let _ = print_string "Expected result: ''\n"
let _ = print_string ((queue2_to_string string_of_int q) ^ "\n")

(***** Testing map2 *****)
let q = (enq2 (enq2 (enq2 (enq2 empty_queue2 1) 2) 3) 4)

let q = map2 (fun n -> if n mod 2 = 0 then "even" else "odd") q
(* Result: 'odd even odd even' *)
let _ = print_string "Expected result: odd even odd even\n"
let _ = print_string ((queue2_to_string (fun a -> a) q) ^ "\n")


(*************** queue3 tests ***************)
let rec queue3_to_string f q = "" (* TODO: Write to string function *)
                
let _ = print_string "*****Testing queue3*****\n"

(***** Testing enq3 and deq3 *****)
let q = empty_queue3()
let _ = enq3 q 1 
(* Result: '1' *)
let _ = print_string "Expected result: 1\n"
let _ = print_string ((queue3_to_string string_of_int q) ^ "\n")

let _ = enq3 q 2
(* Result: '1 2' *)
let _ = print_string "Expected result: 1 2\n"
let _ = print_string ((queue3_to_string string_of_int q) ^ "\n")

let _ = enq3 q 3
(* Result: '1 2 3' *)
let _ = print_string "Expected result: 1 2 3\n"
let _ = print_string ((queue3_to_string string_of_int q) ^ "\n")

let _ = deq3 q 
(* Result: '2 3' *)
let _ = print_string "Expected result: 2 3\n"
let _ = print_string ((queue3_to_string string_of_int q) ^ "\n")

let _ = enq3 q 4
(* Result: '2 3 4' *)
let _ = print_string "Expected result: 2 3 4\n"
let _ = print_string ((queue3_to_string string_of_int q) ^ "\n")

let _ = deq3 q 
(* Result: '3 4' *)
let _ = print_string "Expected result: 3 4\n"
let _ = print_string ((queue3_to_string string_of_int q) ^ "\n")

let _ = deq3 q 
(* Result: '4' *)
let _ = print_string "Expected result: 4\n"
let _ = print_string ((queue3_to_string string_of_int q) ^ "\n")

let _ = deq3 q 
(* Result: '' *)
let _ = print_string "Expected result: ''\n"
let _ = print_string ((queue3_to_string string_of_int q) ^ "\n")

(***** Testing map3 *****)
let q = empty_queue3()
let _ = enq3 q 1; enq3 q 2; enq3 q 3; enq3 q 4

let q = map3 (fun n -> if n mod 2 = 0 then "even" else "odd") q
(* Result: 'odd even odd even' *)
let _ = print_string "Expected result: odd even odd even\n"
let _ = print_string ((queue3_to_string (fun a -> a) q) ^ "\n")
